#
# Conditional build:
%bcond_without	lua	# don't build Lua bindings
%bcond_without	php	# don't build (any) PHP bindings
%bcond_without	ruby	# don't build Ruby bindings
%bcond_with	php4	# build PHP4 bindings (default PHP5)
#
%include	/usr/lib/rpm/macros.perl
Summary:	Redland RDF Application Framework Bindings
Summary(pl.UTF-8):	Wiązania szkieletu aplikacji Redland RDF
Name:		redland-bindings
Version:	1.0.14.1
Release:	3
License:	LGPL v2.1+ or GPL v2+ or Apache v2.0+
Group:		Libraries
Source0:	http://download.librdf.org/source/%{name}-%{version}.tar.gz
# Source0-md5:	293241365303153d7d0635a76e2dd8d3
Patch0:		%{name}-py_sitescriptdir.patch
Patch1:		%{name}-php.patch
Patch2:		%{name}-sh.patch
Patch3:		%{name}-ruby.patch
URL:		http://librdf.org/bindings/
BuildRequires:	autoconf >= 2.53
BuildRequires:	automake >= 1:1.11
BuildRequires:	libtool
%{?with_lua:BuildRequires:	lua51-devel >= 5.1}
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	pkgconfig
BuildRequires:	python-devel
BuildRequires:	redland-devel >= 1.0.14
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.344
%if %{with php}
%if %{with php4}
BuildRequires:	php4-cli
BuildRequires:	php4-devel
%else
BuildRequires:	php-cli >= 3:5.0.0
BuildRequires:	php-devel >= 3:5.0.0
%endif
BuildRequires:	swig-php >= 2.0
%endif
%if %{with ruby}
BuildRequires:	ruby-devel
%endif
Obsoletes:	dotnet-redland
Obsoletes:	java-redland
Obsoletes:	tcl-redland
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Redland is a library that provides a high-level interface for the
Resource Description Framework (RDF) allowing the RDF graph to be
parsed from XML, stored, queried and manipulated. Redland implements
each of the RDF concepts in its own class via an object based API,
reflected into the language APIs, currently Lua, Perl, PHP, Python and
Ruby. Several classes providing functionality such as for parsers,
storage are built as modules that can be loaded at compile or run-time
as required.

%description -l pl.UTF-8
Redland to biblioteka dostarczająca wysokopoziomowy interfejs dla
szkieletu opisu zasobów (RDF - Resource Description Framework),
umożliwiająca na przetwarzanie grafów XML z RDF, przechowywanie,
odpytywanie i obrabianie ich. Redland implementuje wszystkie idee RDF
we własnych klasach poprzez API oparte na obiektach, mających
odzwierciedlenie w API dla poszczególnych języków - aktualnie Lua,
Perla, PHP, Pythona i Ruby'ego. Kilka klas dostarczających
funkcjonalność dla analizatorów i przechowywania danych jest budowana
jako moduły, które mogą być wczytywane w czasie kompilacji lub
działania programu w razie potrzeby.

%package -n lua-redland
Summary:	Lua bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs języka Lua do biblioteki Redland RDF
Group:		Development/Languages/Perl
Requires:	redland >= 1.0.14

%description -n lua-redland
Lua bindings for Redland RDF library.

%description -n lua-redland -l pl.UTF-8
Interfejs języka Lua do biblioteki Redland RDF.

%package -n perl-RDF-Redland
Summary:	Perl bindings for Redland RDF library
Summary(pl.UTF-8):	Perlowy interfejs do biblioteki Redland RDF
Group:		Development/Languages/Perl
Requires:	redland >= 1.0.14

%description -n perl-RDF-Redland
Perl bindings for Redland RDF library.

%description -n perl-RDF-Redland -l pl.UTF-8
Perlowy interfejs do biblioteki Redland RDF.

%package -n php4-redland
Summary:	PHP bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs PHP do biblioteki Redland RDF
Group:		Libraries
%{?requires_php_extension}
Requires:	php4-common >= 3:4.4.0-3
Requires:	redland >= 1.0.14

%description -n php4-redland
PHP 4.x bindings for Redland RDF library.

%description -n php4-redland -l pl.UTF-8
Interfejs PHP 4.x do biblioteki Redland RDF.

%package -n php-redland
Summary:	PHP 5.x bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs PHP 5.x do biblioteki Redland RDF
Group:		Libraries
%{?requires_php_extension}
Requires:	php(core) >= 5.0.4
Requires:	redland >= 1.0.14

%description -n php-redland
PHP 5.x bindings for Redland RDF library.

%description -n php-redland -l pl.UTF-8
Interfejs PHP 5.x do biblioteki Redland RDF.

%package -n python-redland
Summary:	Python bindings for Redland RDF library
Summary(pl.UTF-8):	Pythonowy interfejs do biblioteki Redland RDF
Group:		Libraries/Python
Requires:	redland >= 1.0.14
%pyrequires_eq	python

%description -n python-redland
Python bindings for Redland RDF library.

%description -n python-redland -l pl.UTF-8
Pythonowy interfejs do biblioteki Redland RDF.

%package -n ruby-redland
Summary:	Ruby bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs języka Ruby do biblioteki Redland RDF
Group:		Libraries
Requires:	redland >= 1.0.14
%{?ruby_mod_ver_requires_eq}

%description -n ruby-redland
Ruby bindings for Redland RDF library.

%description -n ruby-redland -l pl.UTF-8
Interfejs języka Ruby do biblioteki Redland RDF.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

# force regeneration
%{__rm} php/{php_redland.h,redland_wrap.c}

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	--disable-static \
	%{?with_lua:--with-lua=lua51} \
	--with-perl \
	--with-perl-makemaker-args='INSTALLDIRS=vendor OPTIMIZE="%{rpmcflags}"' \
%if %{with php}
	PHP_CONFIG=%{_bindir}/php%{?with_php4:4}-config \
	--with-php=%{_bindir}/php%{?with_php4:4}.cli \
%endif
	--with-python \
	%{?with_ruby:--with-ruby}

%{__make} \
	pythondir=%{py_sitedir}

%if %{with ruby}
cd ruby
rdoc --op ../rdoc
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	pythondir=%{py_sitedir} \
	luadir=%{_libdir}/lua/5.1

%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir}
%{__rm} $RPM_BUILD_ROOT%{py_sitescriptdir}/*.py

%if %{with lua}
chmod +x $RPM_BUILD_ROOT%{_libdir}/lua/5.1/*.so
%endif
%if %{with php}
install -d $RPM_BUILD_ROOT{%{php_sysconfdir}/conf.d,%{php_extensiondir}}
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/redland.ini
; Enable redland bindings module
extension=redland.so
EOF
# make .so executable so that rpm would add autodeps on .so files
chmod +x $RPM_BUILD_ROOT%{php_extensiondir}/*.so
%endif

rm -f $RPM_BUILD_ROOT%{perl_archlib}/perllocal.pod
rm -f $RPM_BUILD_ROOT%{perl_vendorarch}/auto/RDF/Redland/CORE/.packlist

%clean
rm -rf $RPM_BUILD_ROOT

%post -n php-redland
%php_webserver_restart

%postun -n php-redland
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%post -n php4-redland
%php4_webserver_restart

%postun -n php4-redland
if [ "$1" = 0 ]; then
	%php4_webserver_restart
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog* LICENSE.html NEWS.html README.html RELEASE.html TODO.html

%if %{with lua}
%files -n lua-redland
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lua/5.1/redland.so
%endif

%files -n perl-RDF-Redland
%defattr(644,root,root,755)
%doc docs/perl.html
%dir %{perl_vendorarch}/RDF
%{perl_vendorarch}/RDF/Redland.pm
%{perl_vendorarch}/RDF/Redland
%dir %{perl_vendorarch}/auto/RDF
%dir %{perl_vendorarch}/auto/RDF/Redland
%dir %{perl_vendorarch}/auto/RDF/Redland/CORE
%{perl_vendorarch}/auto/RDF/Redland/CORE/CORE.bs
%attr(755,root,root) %{perl_vendorarch}/auto/RDF/Redland/CORE/CORE.so
%{_mandir}/man3/RDF::Redland*.3pm*

%if %{with php}
%files -n php%{?with_php4:4}-redland
%defattr(644,root,root,755)
%doc docs/php.html
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/redland.ini
%attr(755,root,root) %{php_extensiondir}/redland.so
%endif

%files -n python-redland
%defattr(644,root,root,755)
%doc docs/python.html docs/pydoc
%{py_sitescriptdir}/RDF.py[co]
%attr(755,root,root) %{py_sitedir}/Redland.so

%if %{with ruby}
%files -n ruby-redland
%defattr(644,root,root,755)
%doc docs/ruby.html rdoc
%attr(755,root,root) %{ruby_archdir}/redland.so
%dir %{ruby_rubylibdir}/rdf
%{ruby_rubylibdir}/rdf/redland.rb
%{ruby_rubylibdir}/rdf/redland
%endif
%changelog
* Thu Aug 23 2012 Elan Ruusamäe <glen@delfi.ee> 67ec595
- use php(core) as dependency to require php version
- release 2 (by relup.sh)

* Mon Aug 06 2012 Elan Ruusamäe <glen@delfi.ee> 85077db
- release 2 (by relup.sh)

* Sun Nov 27 2011 Jakub Bogusz <qboosh@pld-linux.org> 52243c2
- updated 1.0.14.1
- updated php patch
- package lua binding

* Fri Mar 25 2011 Jakub Bogusz <qboosh@pld-linux.org> f60c3f1
- updated to 1.0.13.1 (for redland 1.0.13)
- added sh patch to fix sh syntax in php version check
- added ruby patch to update ruby include dir

* Sat Nov 20 2010 Jakub Bogusz <qboosh@pld-linux.org> 1ec896c
- updated language list, pl fix

* Sat Nov 20 2010 Jakub Bogusz <qboosh@pld-linux.org> 1e5961a
- updated am version

* Sat Nov 20 2010 Jakub Bogusz <qboosh@pld-linux.org> f179a1c
- up to 1.0.11.1 (not tested, current redland (1.0.12) is unsupported)
- updated patches

* Sun Aug 09 2009 aredridel <aredridel@pld-linux.org> befe8cf
- make buildrequires more specific

* Mon Aug 25 2008 Jakub Bogusz <qboosh@pld-linux.org> 5151d7d
- updated to 1.0.8.1
- updated py_sitescriptdir patch

* Mon Aug 25 2008 Jakub Bogusz <qboosh@pld-linux.org> 9a35a6b
- updated for 1.0.8.1

* Sat Feb 09 2008 Jakub Bogusz <qboosh@pld-linux.org> 5bee8fc
- unified License format

* Sun Jan 06 2008 Jakub Bogusz <qboosh@pld-linux.org> f3f0138
- updated to 1.0.7.1; C#, Java and Tcl bindings dropped
- removed obsolete csharp patch, added php patch

* Sun Jan 06 2008 Jakub Bogusz <qboosh@pld-linux.org> 5b2f564
- bugfix

* Sun Jan 06 2008 Jakub Bogusz <qboosh@pld-linux.org> 3322f4e
- outdated, C# binding dropped

* Sat May 12 2007 Jakub Bogusz <qboosh@pld-linux.org> 035e57b
- updated to 1.0.6.1

* Mon Mar 19 2007 Elan Ruusamäe <glen@pld-linux.org> bbab72d
- AC-branch merge

* Mon Mar 19 2007 Elan Ruusamäe <glen@pld-linux.org> 2eca4f6
- merge chunks

* Mon Mar 19 2007 Elan Ruusamäe <glen@pld-linux.org> 24ea701
- allow disabling csharp bindings

* Mon Mar 19 2007 Elan Ruusamäe <glen@pld-linux.org> eaba29c
- specify rootdir for pnet based install

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 638cfcf
- tabs in preamble

